<?php
class ControllerExtensionPaymentmabna2 extends Controller {
	public function index() {
		$this->language->load('extension/payment/mabna2');
    	$data['button_confirm'] = $this->language->get('button_confirm');

		$data['text_loading'] = $this->language->get('text_loading');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$data['order_id'] = $this->session->data['order_id'];
		$data['back'] = $this->url->link('checkout/payment', '', true);
		$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$amount = round($amount);
		$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
			
        $data['order_id'] = $this->session->data['order_id'];
		$data['redirect_url']  =  ($this->url->link('extension/payment/mabna2/callback','', true));
		$data['action'] = "https://mabna.shaparak.ir:8080";
		
		$amount = trim($amount);
		$invoiceNumber = time();
		$redirectAddress =$data['redirect_url'];
		$terminal = trim($this->config->get('mabna2_terminal'));
		
		$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;
		
		$data['TerminalID']=$terminal;
		$data['Amount']=$amount;
		$data['callbackURL']=$redirectAddress;
		$data['InvoiceID']=$invoiceNumber;

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/mabna2.tpl')) {

			return $this->load->view($this->config->get('config_template') . '/template/payment/mabna2.tpl', $data);

		} else {

			return $this->load->view('default/template/payment/mabna2.tpl', $data);

		}
	}

	public function callback() 
	{
		$this->language->load('payment/mabna2');
		@session_start();

		$order_id = isset($this->session->data['order_id']) ? $this->session->data['order_id'] : 0;

		$this->document->setTitle($this->language->get('text_heading'));
		$data['text_wait'] = $this->language->get('text_wait');
		$data['text_heading'] = $this->language->get('text_heading');
		$data['text_results'] = $this->language->get('text_results');
		$data['button_confirm'] = $this->language->get('button_confirm');
		$data['button_continue'] = $this->language->get('button_continue');
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/home', '', 'SSL'), 'separator' => false);
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_heading'), 'href' => $this->url->link('payment/mabna2/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$data['error_warning'] = '';

		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$terminal = trim($this->config->get('mabna2_terminal'));
			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);
			
			$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$amount = round($amount);
			$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
	
			if ($order_info) 
			{
				$_POST['digitalreceipt'] = $this->db->escape($this->request->post["digitalreceipt"]);
				$order_history = $this->db->query("SELECT count(*) as cc FROM " . DB_PREFIX . "order_history WHERE comment = '" .$_POST['digitalreceipt']. "'");
				if ($order_history->num_rows && $order_history->row['cc'] == 0) 
				{
					$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
					curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
					$result = json_decode($res,true);
					 if (strtoupper($result['Status']) == 'OK') 
					 {
						 
						if(floatval($result['ReturnId'])  == floatval($amount))
						{
							$referenceId = $_POST['digitalreceipt'];
							$data['authority'] = $referenceId;
							$data['continue'] = $this->url->link('checkout/success');
							$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('mabna2_order_status_id'),$referenceId, true);
							$data['error_warning'] = NULL;
							$location = ($this->url->link('checkout/success', '', 'SSL'));
							
							if (!headers_sent()) {
								header('Location: ' . $location);
							  } else
							  {
								  echo '<script type="text/javascript">';
								  echo 'window.location.href="' . $location . '";';
								  echo '</script>';
							  }

						}
						else
						{
							$res = 'مبلغ واریز با قیمت محصول برابر نیست ، مبلغ واریزی :'.$result['ReturnId'];
							$data['continue'] = $this->url->link('checkout/checkout');
						}
						
					}
					else 
					{
						switch($result['ReturnId'])
						{
							case '-1' : $res = 'تراکنش پیدا نشد';break;
							case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
							case '-3' : $res = 'خطا عمومی';break;
							case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
							case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
							default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
							
						}
						$data['error_warning'] = $res;
						$data['continue'] = $this->url->link('checkout/checkout');
					}
				}
				else 
				{
					$data['error_warning'] ='رسید دیجیتال قبلا استفاده شده است';
					$data['continue'] = $this->url->link('checkout/checkout');
				}
				}	
				else 
				{
					$data['error_warning'] =$this->language->get('error_order_id');
					$data['continue'] = $this->url->link('checkout/checkout');
				}			
		}
		else 
		{
			$data['error_warning'] = $this->language->get('error_order_2');
			$data['continue'] = $this->url->link('checkout/checkout');
		}
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/mabna2_confirm.tpl')) 
		{
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/mabna2_confirm.tpl', $data));

		} else 
		{
			$this->response->setOutput($this->load->view('default/template/payment/mabna2_confirm.tpl', $data));
		}
	

	}
}
?>